# Matt666 Juil. 2008

# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.

#Create a toolbar that easily toggle units 

#Thanks to CadFather for the icons !! ^^
# 12 avril 2010 correction  du pilotage des dimensions par adebeo
def toggle_units(int)
	model = Sketchup.active_model
	case int
		when 0,1,2,3,4
		model.options[0][2] = int
		
		when 5,6,7,8
		result = int - 5
		case result
		when 0;model.options["UnitsOptions"][1] = 0
		when 1;model.options["UnitsOptions"][1] = 1
		when 2;model.options["UnitsOptions"][1] = 2
		when 3;model.options["UnitsOptions"][1] = 3
		end
		model.options[0][1] = result
	end
	model.active_view.invalidate
	return nil
end

def toggle_units_validation_proc(int)
	case int
		when 0,1,2,3,4
		if Sketchup.active_model.options[0][1] != 0
			return MF_GRAYED
		else
			if Sketchup.active_model.options[0][2] == int
				return MF_CHECKED
			else
				return MF_UNCHECKED
			end
		end
		when 5,6,7,8
		result = int - 5
		if Sketchup.active_model.options[0][1] == result
			return MF_CHECKED
		else
			return MF_UNCHECKED
		end
	end
end

def toggle_Length_Precision(int)
	model = Sketchup.active_model
	return if not [1,-1].index(int)
	lp = model.options["UnitsOptions"]["LengthPrecision"]
	if 0 <= (lp + int) && (lp + int) <= 10
		model.options["UnitsOptions"]["LengthPrecision"] = lp + int
		puts "Drawing precision = " + (lp + int).to_s
	end
	model.active_view.invalidate
end

def display_unit_format
	model = Sketchup.active_model
	if model.options["UnitsOptions"]["SuppressUnitsDisplay"] == true
		model.options["UnitsOptions"]["SuppressUnitsDisplay"]= false
	else
		model.options["UnitsOptions"]["SuppressUnitsDisplay"]= true
	end
	model.active_view.invalidate
end
def display_unit_format_validation_proc
	if Sketchup.active_model.options["UnitsOptions"]["SuppressUnitsDisplay"] == true
		return MF_UNCHECKED
	else
		return MF_CHECKED
	end
end


if not file_loaded?("toggle_units.rb")
	
	u_menu = UI.menu("Plugins").add_submenu("Toggle units")
		u_menu.add_item("Decimal") { toggle_units(5) }
		u_menu.add_item("Architectural") { toggle_units(6) }
		u_menu.add_item("Fractionnal") { toggle_units(7) }
		u_menu.add_item("Ingeniery") { toggle_units(8) }
		u_menu.add_item("Feet") { toggle_units(1) }
		u_menu.add_item("Inch") { toggle_units(0) }
		u_menu.add_item("Millimeter") { toggle_units(2) }
		u_menu.add_item("Centimeter") { toggle_units(3) }
		u_menu.add_item("Meter") { toggle_units(4) }
		u_menu.add_separator
		u_menu.add_item("Decrease precision") { toggle_Length_Precision(-1) }
		u_menu.add_item("Increase precision") { toggle_Length_Precision(1) }
		u_menu.add_separator
		u_menu.add_item("Display format") {	display_unit_format }
		
	tb = UI::Toolbar.new("Toggle units")
	ext = ".png"
	path = File.join("Plugins","toggle_units_icons")
	
	cmd = UI::Command.new("Decimal") { toggle_units(5) }
	cmd.small_icon = Sketchup.find_support_file(("tudec_16" + ext),path)
	cmd.large_icon = Sketchup.find_support_file(("tudec_24" + ext),path)
	cmd.tooltip = cmd.status_bar_text = "Drawing unit -> Decimal"
	cmd.set_validation_proc { toggle_units_validation_proc(5) }
	tb.add_item cmd
	
	cmd = UI::Command.new("Architectural") { toggle_units(6) }
	cmd.small_icon = Sketchup.find_support_file(("tuarc_16" + ext),path)
	cmd.large_icon = Sketchup.find_support_file(("tuarc_24" + ext),path)
	cmd.tooltip = cmd.status_bar_text = "Drawing unit -> Architectural"
	cmd.set_validation_proc { toggle_units_validation_proc(6) }
	tb.add_item cmd
	
	cmd = UI::Command.new("Fractionnal") { toggle_units(8) }
	cmd.small_icon = Sketchup.find_support_file(("tufra_16" + ext),path)
	cmd.large_icon = Sketchup.find_support_file(("tufra_24" + ext),path)
	cmd.tooltip = cmd.status_bar_text = "Drawing unit -> Fractionnal"
	cmd.set_validation_proc { toggle_units_validation_proc(8) }
	tb.add_item cmd
	
	cmd = UI::Command.new("Ingeniery") { toggle_units(7) }
	cmd.small_icon = Sketchup.find_support_file(("tuing_16" + ext),path)
	cmd.large_icon = Sketchup.find_support_file(("tuing_24" + ext),path)
	cmd.tooltip = cmd.status_bar_text = "Drawing unit -> Ingeniery"
	cmd.set_validation_proc { toggle_units_validation_proc(7) }
	tb.add_item cmd
	
	tb.add_separator
	tb.add_separator
	
	cmd = UI::Command.new("Inch") { toggle_units(0) }
	cmd.small_icon = Sketchup.find_support_file(("tuin_16" + ext),path)
	cmd.large_icon = Sketchup.find_support_file(("tuin_24" + ext),path)
	cmd.tooltip = cmd.status_bar_text = "Drawing unit -> Inch"
	cmd.set_validation_proc { toggle_units_validation_proc(0) }
	tb.add_item cmd
	
	cmd = UI::Command.new("Feet") { toggle_units(1) }
	cmd.small_icon = Sketchup.find_support_file(("tufe_16" + ext),path)
	cmd.large_icon = Sketchup.find_support_file(("tufe_24" + ext),path)
	cmd.tooltip = cmd.status_bar_text = "Drawing unit -> Feet"
	cmd.set_validation_proc { toggle_units_validation_proc(1) }
	tb.add_item cmd

	tb.add_separator
	
	cmd = UI::Command.new("Millimeter") { toggle_units(2) }
	cmd.small_icon = Sketchup.find_support_file(("tumm_16" + ext),path)
	cmd.large_icon = Sketchup.find_support_file(("tumm_24" + ext),path)
	cmd.tooltip = cmd.status_bar_text = "Drawing unit -> Millimeter"
	cmd.set_validation_proc { toggle_units_validation_proc(2) }
	tb.add_item cmd
	
	cmd = UI::Command.new("Centimeter") { toggle_units(3) }
	cmd.small_icon = Sketchup.find_support_file(("tucm_16" + ext),path)
	cmd.large_icon = Sketchup.find_support_file(("tucm_24" + ext),path)
	cmd.tooltip = cmd.status_bar_text = "Drawing unit -> Centimeter"
	cmd.set_validation_proc { toggle_units_validation_proc(3) }
	tb.add_item cmd
	
	cmd = UI::Command.new("Meter") { toggle_units(4) }
	cmd.small_icon = Sketchup.find_support_file(("tume_16" + ext),path)
	cmd.large_icon = Sketchup.find_support_file(("tume_24" + ext),path)
	cmd.tooltip = cmd.status_bar_text = "Drawing unit -> Meter"
	cmd.set_validation_proc { toggle_units_validation_proc(4) }
	tb.add_item cmd
	
	tb.add_separator
	tb.add_separator
	
	cmd = UI::Command.new("Decrease Drawing precision") { toggle_Length_Precision(-1) }
	cmd.small_icon = Sketchup.find_support_file(("tumoins_16" + ext),path)
	cmd.large_icon = Sketchup.find_support_file(("tumoins_24" + ext),path)
	cmd.tooltip = cmd.status_bar_text = "Decrease Drawing precision"
	tb.add_item cmd
	
	cmd = UI::Command.new("Increase Drawing precision") { toggle_Length_Precision(1) }
	cmd.small_icon = Sketchup.find_support_file(("tuplus_16" + ext),path)
	cmd.large_icon = Sketchup.find_support_file(("tuplus_24" + ext),path)
	cmd.tooltip = cmd.status_bar_text = "Increase Drawing precision"
	tb.add_item cmd
	
	tb.add_separator
	
	cmd = UI::Command.new("Display format") { display_unit_format }
	cmd.small_icon = Sketchup.find_support_file(("duf_16" + ext),path)
	cmd.large_icon = Sketchup.find_support_file(("duf_24" + ext),path)
	cmd.tooltip = cmd.status_bar_text = "Display unit format"
	cmd.set_validation_proc { display_unit_format_validation_proc }
	tb.add_item cmd
	
	state = tb.get_last_state
	
	if(state == TB_NEVER_SHOWN)
		tb.show 
	elsif (state == TB_VISIBLE)
		tb.restore
	end
	file_loaded("toggle_units.rb")
end
